#include "cdio/compat/device.h"

#include "cdio/compat/version.h"

#include "stdlib.h"


// FFI-compatible wrappers

const unsigned int vendor_len() {
    return CDIO_MMC_HW_VENDOR_LEN;
}

const unsigned int model_len() {
    return CDIO_MMC_HW_MODEL_LEN;
}

const unsigned int revision_len() {
    return CDIO_MMC_HW_REVISION_LEN;
}


bitfield_t drive_cap_error() {
    return CDIO_DRIVE_CAP_ERROR;
}

bitfield_t drive_cap_unknown() {
    return CDIO_DRIVE_CAP_UNKNOWN;
}


const driver_id_t* get_drivers() {
    return cdio_drivers;
}

const driver_id_t* get_device_drivers() {
    return cdio_device_drivers;
}

const driver_id_t get_os_driver() {
    return cdio_os_driver;
}


// Symbol compatibility definitions

CdIo_t* cdio_open_bsdi_safe(const char* src) {
#if LIBCDIO_SINCE_VERSION_1_0
    return NULL;
#else
    return cdio_open_bsdi(src);
#endif
}

CdIo_t* cdio_open_am_bsdi_safe(const char* src, const char* mode) {
#if LIBCDIO_SINCE_VERSION_1_0
    return NULL;
#else
    return cdio_open_am_bsdi(src, mode);
#endif
}

char* cdio_get_default_device_bsdi_safe() {
#if LIBCDIO_SINCE_VERSION_1_0
    return NULL;
#else
    return cdio_get_default_device_bsdi();
#endif
}

char** cdio_get_devices_bsdi_safe() {
#if LIBCDIO_SINCE_VERSION_1_0
    return NULL;
#else
    return cdio_get_devices_bsdi();
#endif
}


CdIo_t* cdio_open_os2_safe(const char* src) {
#if LIBCDIO_SINCE_VERSION_1_0
    return NULL;
#else
    return cdio_open_os2(src);
#endif
}

CdIo_t* cdio_open_am_os2_safe(const char* src, const char* mode) {
#if LIBCDIO_SINCE_VERSION_1_0
    return NULL;
#else
    return cdio_open_am_os2(src, mode);
#endif
}

char* cdio_get_default_device_os2_safe() {
#if LIBCDIO_SINCE_VERSION_1_0
    return NULL;
#else
    return cdio_get_default_device_os2();
#endif
}

char** cdio_get_devices_os2_safe() {
#if LIBCDIO_SINCE_VERSION_1_0
    return NULL;
#else
    return cdio_get_devices_os2();
#endif
}
