{-|
Description:    

Copyright:      (c) 2019 Sam May
License:        GPL-3.0-or-later
Maintainer:     ag@eitilt.life

Stability:      experimental
Portability:    portable
-}
module Main where


import qualified Control.Monad as M
import qualified System.Exit as E
import qualified Test.HUnit as U

import qualified Data.Text.Encoding.MsJIS.Test.Unit as MsJIS

import qualified Test.Libcdio.Unit.Foreign.CarolusRex as Rex
import qualified Test.Libcdio.Unit.Foreign.DeeperDance as Dance
import qualified Test.Libcdio.Unit.Foreign.RevolutionDays as Revolution

import qualified Test.Libcdio.Unit.Sound.CarolusRex as S.Rex
import qualified Test.Libcdio.Unit.Sound.DeeperDance as S.Dance
import qualified Test.Libcdio.Unit.Sound.RevolutionDays as S.Revolution


main :: IO ()
main = do
    results <- U.runTestTT $ U.TestList
        [ MsJIS.tests
        , Dance.tests
        , Revolution.tests
        , Rex.tests
        , S.Dance.tests
        , S.Rex.tests
        , S.Revolution.tests
        ]
    
    M.unless (U.errors results == 0 && U.failures results == 0) E.exitFailure
